<?php
// +-----------------------------------------------------------------------+
// | Mod Name : UserDir                                                    |
// | Mod Version : 0.1                                                     |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

class UserDir
{
  var $plugin_name, $plugin_path, $plugin_url;

  function UserDir($plugin_name, $plugin_path, $plugin_url)
  {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    $this->plugin_url = $plugin_url;
    // handler
    $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);
  }

  function initialize_event_handler()
  {
    $this->load_lang(); // Chargement des langues

    add_event_handler('register_user', array(&$this, 'CreateDir'));
    add_event_handler('check_access_upload', array(&$this, 'CheckAccessUpload'));
  }

  // Chargement des fichiers langues
  function load_lang()
  {
    global $lang;
    include(get_language_filepath('plugin.lang.php', $this->plugin_path) );
  }

  // Controle l'accès à l'upload
  // Comparaison entre le nom d'utilisateur et
  // la catégorie qui lui est attribué
  function CheckAccessUpload($check_access_upload)
  {
    global $prefixeTable, $lang;

    $id_user = $check_access_upload['id_user'];
    $id_category = $check_access_upload['id_category'];

    $query = ' 
SELECT COUNT(*)
FROM '.$prefixeTable.'user_dir
  WHERE id_user=\''.$id_user.'\'
  AND id_category=\''.$id_category.'\'
;';

    $nombre = mysql_fetch_array(pwg_query($query)); 
    if ($nombre[0] == 0)
    {
      $url = get_absolute_root_url();
      $msg = $lang['ud_not_authorize'];
      redirect_html($url , $msg, $refresh_time = 5);
    }
  }

  function CreateDir($register_user)
  {
    // Contrôle les caractères spéciaux
    // et les remplaces par une valeur correcte
    $dirname = remove_accents($register_user['username']);
    mkdir(PHPWG_ROOT_PATH.'/galleries/'.$dirname);

    // Création de la catégorie
    $this->UpdateCategory($register_user, $dirname);
    $this->CreateIndexFile($dirname);
  }

  function UpdateCategory($register_user, $dirname)
  {
    global $conf, $prefixeTable;

    $inserts = array(); 

    // Selection de l'identifiant le plus grand
    // et ajoute 1.
    $query = '
SELECT IF(MAX(id)+1 IS NULL, 1, MAX(id)+1) AS next_id
  FROM '.CATEGORIES_TABLE.'
;';
    list($next_id) = mysql_fetch_array(pwg_query($query));

    $status = $conf['newcat_default_status'];
    $visible = $conf['newcat_default_visible'];
    $uploadable = $conf['newcat_default_uploadable'];
    $commentable = $conf['newcat_default_commentable'];
    $dirtitle = $register_user['username'];
    
    $insert = array(
      'id'          => $next_id,
      'nb_images'   => '0',
      'name'        => str_replace('_', ' ', $dirtitle),
      'id_uppercat' => '',
      'comment'     => '',
      'dir'         => $dirname,
      'rank'        => $next_id,
      'status'      => $status,
      'site_id'     => '1',
      'visible'     => boolean_to_string($visible),
      'uploadable'  => boolean_to_string($uploadable),
      'representative_picture_id' => '',
      'uppercats'   => $next_id,
      'commentable' => boolean_to_string($commentable),
      'global_rank' => $next_id
    );

    array_push($inserts, $insert);

    $dbfields = array(
      'id','nb_images','name','id_uppercat','comment','dir','rank',
      'status','site_id','visible','uploadable','representative_picture_id',
      'uppercats','commentable','global_rank'
    );
    mass_inserts(CATEGORIES_TABLE, $dbfields, $inserts);

    // Insertion de la correspondance id category
    // id utilisateur
    $this->InsertDir($register_user, $next_id);
  }

  // Insertion de la correspondance identifiant
  // utilisateur et nom du répertoire
  function InsertDir($register_user, $next_id)
  {
    global $prefixeTable;

    $query = '
      INSERT INTO '.$prefixeTable.'user_dir(id_user, id_category)
      VALUES(\''.$register_user['id'].'\', \''.$next_id.'\')
      ;';
    $result = pwg_query($query);
  }

  function CreateIndexFile($dirname)
  {
    copy(PHPWG_ROOT_PATH.'/galleries/index.php', PHPWG_ROOT_PATH.'/galleries/'.$dirname.'/index.php');
  }
}
?>